Summary:	heartbeat - heartbeat subsystem for High-Availability Linux
Name:		heartbeat
Version:	2.0.8
Release:	1tr
Copyright:	GPL
URL:		http://linux-ha.org/
Group:		Trustix Official
Source0:	http://linux-ha.org/download/heartbeat-%{version}.tar.gz
Source1:	IPsrcaddr2.sh
Patch:		heartbeat-init.patch
Patch1:		heartbeat-lvssyncdaemon.patch
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildPrereq:	perl, iputils, /usr/bin/ssh, openssl-devel, libnet-devel, libxml2-devel
PreReq:		/sbin/chkconfig, /sbin/restart_maybe
Requires:	sysklogd, heartbeat-stonith = %{version}-%{release}, heartbeat-pils = %{version}-%{release}


%define libheart	heartbeat-libs
%define libstonith	heartbeat-stonith-libs
%define libpils		heartbeat-pils-libs


%description
heartbeat is a basic high-availability subsystem for Linux-HA.  It will run
scripts at initialization, and when machines go up or down.  This version will
also perform IP address takeover using gratuitous ARPs.  It works correctly for
a 2-node configuration, and is extensible to larger configurations.

It implements the following kinds of heartbeats:
	- Bidirectional Serial Rings ("raw" serial ports)
	- UDP/IP broadcast (ethernet, etc)
	- Unicast heartbeats
	- "ping" heartbeats (for routers, switches, etc.)
	   (to be used for breaking ties in 2-node systems)


%package -n %libheart
Summary:	Development files from heartbeat
Group:		Trustix Official
Provides:	lib%name = %version-%release

%description -n %libheart
Library needed by heartbeat. Heartbeat is a basic heartbeat subsystem for
Linux-HA.


%package -n %libheart-devel
Summary:	Development files from heartbeat
Group:		Trustix Official
Provides:	lib%name-devel = %version-%release
Requires:	%libheart = %version-%release

%description -n %libheart-devel
Development files from heartbeat. Heartbeat is a basic heartbeat subsystem for
Linux-HA.


%package ldirectord
Summary:	Monitor daemon for maintaining high availability resources
Group:		Trustix Official
Requires:	perl, perl-libwww-perl, perl-html-parser, perl-net-ssleay, perl-ldap, ipvsadm
PreReq:		/sbin/chkconfig, /sbin/restart_maybe


%description ldirectord
ldirectord is a stand-alone daemon to monitor services of real for virtual
services provided by The Linux Virtual Server
(http://www.linuxvirtualserver.org/). It is simple to install and works with
the heartbeat code (http://www.linux-ha.org/).


%package stonith
Summary:	Provides an interface to Shoot The Other Node In The Head 
Requires:	telnet, heartbeat-pils = %{version}-%{release}, net-snmp >= 5.3
Group:		Trustix Official


%description stonith
The STONITH module (a.k.a. STOMITH) provides an extensible interface
for remotely powering down a node in the cluster.  The idea is quite simple:
When the software running on one machine wants to make sure another
machine in the cluster is not using a resource, pull the plug on the other 
machine. It's simple and reliable, albeit admittedly brutal.


%package -n %libstonith
Summary:	Library from heartbeat
Group:		Trustix Official
Provides:	libstonith = %version-%release
Provides:	libhearbeat-stonith = %version-%release

%description -n %libstonith
Library needed by heartbeat-stonith. The STONITH module (a.k.a. STOMITH)
provides an extensible interface for remotely powering down a node in the
cluster.


%package -n %libstonith-devel
Summary:	Development files from heartbeat
Group:		Trustix Official
Provides:	libstonith-devel = %version-%release
Provides:	libhearbeat-stonith-devel = %version-%release
Requires:	%libstonith = %version-%release

%description -n %libstonith-devel
Development files from heartbeat-stonith. The STONITH module (a.k.a. STOMITH)
provides an extensible interface for remotely powering down a node in the
cluster.


%package pils
Summary:	Provides a general plugin and interface loading library
Group:		Trustix Official


%description pils
PILS is an generalized and portable open source Plugin and Interface Loading
System. PILS was developed as part of the Open Cluster Framework reference
implementation, and is designed to be directly usable by a wide variety of
other applications. PILS manages both plugins (loadable objects), and the
interfaces these plugins implement.  PILS is designed to support any number of
plugins implementing any number of interfaces.


%package -n %libpils
Summary:	Provides a general plugin and interface loading library
Group:		Trustix Official
Provides:	libpils = %version-%release
Provides:	libheartbeat-pils = %version-%release

%description -n %libpils
Libarary needed by heartbeat-pils. PILS is an generalized and portable open
source Plugin and Interface Loading System. PILS was developed as part of the
Open Cluster Framework reference implementation.


%package -n %libpils-devel
Summary:	Provides a general plugin and interface loading library
Group:		Trustix Official
Requires:	%libpils = %version-%release
Provides:	libpils-devel = %version-%release
Provides:	libheartbeat-pils-devel = %version-%release

%description -n %libpils-devel
Development files from heartbeat-pils. PILS is an generalized and portable open
source Plugin and Interface Loading System. PILS was developed as part of the
Open Cluster Framework reference implementation.


%define user_name  heartbeat
%define user_id    264
%define group_name heartbeat
%define group_id   264


%prep
%setup -q
#%patch0 -b .orig
%patch1 -p1

%build
%configure --with-group-name=%{group_name} --with-group-id=%{group_id} \
	--with-ccmuser-name=%{user_name} --with-ccmuser-id=%{user_id} \
	--enable-ltdl-convenience --disable-fatal-warnings --disable-swig \
        --enable-ldirectord --disable-mgmt
%{__make} %{_smp_mflags}


%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT
%{__make} DESTDIR=%{buildroot} install
(
  cd %{buildroot}%{_sysconfdir}/ha.d/resource.d
  %{__ln_s} %{_sbindir}/ldirectord ldirectord
)

%{__install} -m644 doc/ha.cf  %{buildroot}%{_sysconfdir}/ha.d
%{__install} -m644 doc/haresources  %{buildroot}%{_sysconfdir}/ha.d
%{__install} -m600 doc/authkeys  %{buildroot}%{_sysconfdir}/ha.d

%{__install} -m644 ldirectord/ldirectord.cf %{buildroot}%{_sysconfdir}/ha.d/conf
%{__install} -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/ha.d/resource.d/IPsrcaddr2


%pre
# Dynamically add the heartbeat user BEFORE installing package
if [ -z "`getent group %{group_name}`" ]; then
        /usr/sbin/groupadd -g %{group_id} %{group_name} 
fi
if [ -z "`getent passwd %{user_name}`" ]; then
        /usr/sbin/useradd -d /dev/null -s /no/shell \
        -g heartbeat -u %{user_id} %{user_name}
fi

%post
/sbin/chkconfig --add heartbeat
/sbin/restart_maybe heartbeat

%preun
if [ "$1" = "0" ]; then
    /etc/init.d/heartbeat stop
    /sbin/chkconfig --del heartbeat
fi

%postun
# Dynamically remove the snmpd user AFTER removing package
if [ "$1" = "0" ]; then
        if [ -n "`getent passwd heartbeat`" ]; then
                /usr/sbin/userdel heartbeat
        fi
        if [ -n "`getent group heartbeat`" ]; then
                /usr/sbin/groupdel heartbeat
        fi
fi

%post ldirectord
/sbin/chkconfig --add ldirectord
/sbin/restart_maybe ldirectord > /dev/null 2>&1


%preun ldirectord
if [ $1 = 0 ]; then
        service ldirectord stop > /dev/null 2>&1
        /sbin/chkconfig --del ldirectord
fi


%post -n %libheart -p /sbin/ldconfig
%postun -n %libheart -p /sbin/ldconfig
%post -n %libpils -p /sbin/ldconfig
%postun -n %libpils -p /sbin/ldconfig
%post -n %libstonith -p /sbin/ldconfig
%postun -n %libstonith -p /sbin/ldconfig


%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%dir %{_sysconfdir}/ha.d
%config(noreplace) %{_sysconfdir}/ha.d/ha.cf
%config(noreplace) %{_sysconfdir}/ha.d/haresources
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/ha.d/authkeys
%{_sysconfdir}/ha.d/harc
%{_sysconfdir}/ha.d/shellfuncs
%{_sysconfdir}/ha.d/rc.d
%{_sysconfdir}/ha.d/README.config
%dir %{_sysconfdir}/ha.d/conf/
%attr(2755,heartbeat,heartbeat) %{_bindir}/cl_status
%{_bindir}/cl_respawn
%{_sbindir}/attrd_updater
%{_sbindir}/crm_*
%{_sbindir}/cibadmin
%{_sbindir}/crmadmin
%{_sbindir}/iso8601
%{_sbindir}/ccm_tool
%{_sbindir}/ocf-tester
%{_mandir}/man1/hb_standby*
%{_mandir}/man1/hb_takeover*
%{_mandir}/man8/cibadmin*
%{_mandir}/man8/crm_resource.*
%{_mandir}/man1/cl_status.1*
%{_mandir}/man1/ha_logger.1*
%{_mandir}/man1/hb_addnode.1*
%{_mandir}/man1/hb_delnode.1*
%{_mandir}/man8/ha_logd.8*
%dir %{_libdir}/heartbeat
%{_libdir}/heartbeat/BasicSanityCheck
%{_libdir}/heartbeat/api_test
%{_libdir}/heartbeat/apphbd
%{_libdir}/heartbeat/apphbtest
%{_libdir}/heartbeat/atest
%{_libdir}/heartbeat/attrd
%{_libdir}/heartbeat/base64_md5_test
%{_libdir}/heartbeat/ccm
%{_libdir}/heartbeat/cib
%{_libdir}/heartbeat/cibmon
%{_libdir}/heartbeat/clmtest
%{_libdir}/heartbeat/crm.dtd
%{_libdir}/heartbeat/crmd
%{_libdir}/heartbeat/cts
%{_libdir}/heartbeat/ccm_testclient
%{_libdir}/heartbeat/dopd
%{_libdir}/heartbeat/drbd-peer-outdater
%{_libdir}/heartbeat/findif
%{_libdir}/heartbeat/ha_config
%{_libdir}/heartbeat/ha_logd
%{_libdir}/heartbeat/ha_logger
%{_libdir}/heartbeat/ha_propagate
%{_libdir}/heartbeat/haresources2cib.py
%{_libdir}/heartbeat/hb_addnode
%{_libdir}/heartbeat/hb_delnode
%{_libdir}/heartbeat/hb_setsite
%{_libdir}/heartbeat/hb_setweight
%{_libdir}/heartbeat/hb_standby
%{_libdir}/heartbeat/hb_takeover
%{_libdir}/heartbeat/tengine
%{_libdir}/heartbeat/ttest
%{_libdir}/heartbeat/heartbeat
%{_libdir}/heartbeat/ipctest
%{_libdir}/heartbeat/ipfail
%{_libdir}/heartbeat/logtest
%{_libdir}/heartbeat/lrmadmin
%{_libdir}/heartbeat/lrmd
%{_libdir}/heartbeat/lrmtest/LRMBasicSanityCheck
%{_libdir}/heartbeat/mach_down
%{_libdir}/heartbeat/mlock
%{_libdir}/heartbeat/ocf-returncodes
%{_libdir}/heartbeat/ocf-shellfuncs
%{_libdir}/heartbeat/pengine
%{_libdir}/heartbeat/pingd
%{_libdir}/heartbeat/ptest
%{_libdir}/heartbeat/req_resource
%{_libdir}/heartbeat/send_arp
%{_libdir}/heartbeat/ResourceManager
%{_libdir}/heartbeat/TestHeartbeatComm
%{_libdir}/heartbeat/ipctransientclient
%{_libdir}/heartbeat/ipctransientserver
%{_libdir}/heartbeat/recoverymgrd
%dir %{_libdir}/heartbeat/plugins
%dir %{_libdir}/heartbeat/plugins/*
%{_libdir}/heartbeat/plugins/*/*.so
%{_sysconfdir}/ha.d/resource.d/
%{_initdir}/heartbeat
%{_sysconfdir}/logrotate.d/heartbeat
%dir %{_localstatedir}/lib/heartbeat
%{_mandir}/man8/heartbeat.8*
%{_mandir}/man8/apphbd.8*
%doc doc/*
#%{_libdir}/libhbmgmt.so.*
#%{_libdir}/libhbmgmtclient.so.*
#%{_libdir}/libhbmgmtcommon.so.*
#%{_libdir}/libhbmgmttls.so.*
#%config(noreplace) %{_sysconfdir}/pam.d/hbmgmtd
#%{_datadir}/locale/zh_CN/LC_MESSAGES/haclient.mo
%dir %{_var}/lib/heartbeat
%dir %{_var}/lib/heartbeat/cores
%dir %attr (0755, root, root) %{_var}/lib/heartbeat/cores/root
%dir %attr (0755, nobody, nobody) %{_var}/lib/heartbeat/cores/nobody
%dir %attr (0755, heartbeat, heartbeat) %{_var}/lib/heartbeat/cores/heartbeat
%dir %{_var}/run/heartbeat
%dir %attr (755, heartbeat, heartbeat) %{_var}/run/heartbeat/ccm
%dir %attr (755, heartbeat, heartbeat) %{_var}/run/heartbeat/crm
%dir %attr (755, heartbeat, heartbeat) %{_var}/lib/heartbeat/crm
%dir %attr (755, heartbeat, heartbeat) %{_var}/lib/heartbeat/pengine


%files -n %libheart
%defattr(-,root,root)
%{_libdir}/libhbclient.so.*
%{_libdir}/libapphb.so.*
%{_libdir}/libccmclient.so.*
%{_libdir}/libcib.so.*
%{_libdir}/libclm.so.*
%{_libdir}/liblrm.so.*
%{_libdir}/libcrmcommon.so.*
%{_libdir}/libpengine.so.*
%{_libdir}/libpe_rules.so.*
%{_libdir}/libpe_status.so.*
%{_libdir}/libplumbgpl.so.*
%{_libdir}/librecoverymgr.so.*
%{_libdir}/libtransitioner.so.*
%_prefix/lib/ocf/resource.d/heartbeat/*

%files -n %libheart-devel
%defattr(-,root,root)
%{_libdir}/libapphb.a
%{_libdir}/libapphb.la
%{_libdir}/libccmclient.a
%{_libdir}/libccmclient.la
%{_libdir}/libcib.a
%{_libdir}/libcib.la
%{_libdir}/libclm.a
%{_libdir}/libclm.la
%{_libdir}/libcrmcommon.a
%{_libdir}/libcrmcommon.la
%{_libdir}/libhbclient.a
%{_libdir}/libhbclient.la
%{_libdir}/libpe_rules.a
%{_libdir}/libpe_rules.la
%{_libdir}/libpe_status.a
%{_libdir}/libpe_status.la
%{_libdir}/liblrm.a
%{_libdir}/liblrm.la
%{_libdir}/libpengine.a
%{_libdir}/libpengine.la
%{_libdir}/libplumbgpl.a
%{_libdir}/libplumbgpl.la
%{_libdir}/librecoverymgr.a
%{_libdir}/librecoverymgr.la
%{_libdir}/libtransitioner.a
%{_libdir}/libtransitioner.la
%{_libdir}/libplumb.a
%{_libdir}/libplumb.la
%{_libdir}/heartbeat/plugins/*/*.a
%{_libdir}/heartbeat/plugins/*/*.la
%dir %_includedir/heartbeat
%{_includedir}/heartbeat/*.h
%{_includedir}/heartbeat/crm/
%dir %{_includedir}/ocf
%{_includedir}/ocf/*.h
%dir %{_includedir}/clplumbing
%{_includedir}/clplumbing/*.h
%{_includedir}/saf


%files ldirectord
%defattr(-,root,root)
%{_sbindir}/ldirectord
%{_sbindir}/supervise-ldirectord-config
%{_sysconfdir}/logrotate.d/ldirectord
%{_initdir}/ldirectord
%{_sysconfdir}/ha.d/resource.d/ldirectord
%{_mandir}/man8/ldirectord.8*
%{_mandir}/man8/supervise-ldirectord-config.8*
%doc ldirectord/ldirectord.cf


%files stonith
%defattr(-,root,root)
%{_sbindir}/stonith
%{_sbindir}/meatclient
%{_libdir}/heartbeat/stonithd
%{_libdir}/heartbeat/stonithdtest/STONITHDBasicSanityCheck
%{_libdir}/heartbeat/stonithdtest/apitest
%dir %{_libdir}/stonith
%dir %{_libdir}/stonith/plugins
%dir %{_libdir}/stonith/plugins/stonith2
%dir %{_libdir}/stonith/plugins/external
%{_libdir}/stonith/plugins/stonith2/*.so
%{_libdir}/stonith/plugins/stonith2/ribcl.py
%{_libdir}/stonith/plugins/external/*
%{_mandir}/man8/stonith.8*
%{_mandir}/man8/meatclient.8*


%files -n %libstonith
%defattr(-,root,root)
%{_libdir}/libstonith.so.*
%{_libdir}/libstonithd.so.*

%files -n %libstonith-devel
%defattr(-,root,root)
%{_libdir}/libstonith.a
%{_libdir}/libstonith.la
%{_libdir}/libstonithd.a
%{_libdir}/libstonithd.la
%dir %{_includedir}/stonith
%{_includedir}/stonith/*.h
%{_libdir}/stonith/plugins/stonith2/*.a
%{_libdir}/stonith/plugins/stonith2/*.la


%files pils
%defattr(-,root,root)
%dir %{_libdir}/pils
%dir %{_libdir}/pils/plugins
%dir %{_libdir}/pils/plugins/InterfaceMgr
%{_libdir}/pils/plugins/InterfaceMgr/*.so


%files -n %libpils
%defattr(-,root,root)
%{_libdir}/libpils.so.*
%{_libdir}/libplumb.so.*


%files -n %libpils-devel
%defattr(-,root,root)
%doc README doc/AUTHORS doc/COPYING doc/ChangeLog
%dir %{_includedir}/pils
%{_includedir}/pils/*.h
%{_libdir}/libpils.a
%{_libdir}/libpils.la
%{_libdir}/pils/plugins/InterfaceMgr/*.a
%{_libdir}/pils/plugins/InterfaceMgr/*.la




%changelog
* Thu Apr 19 2007 Nived Gopalan <nived at trustix dot org> 2.0.8-1tr
- New Upstream.

* Thu Jan 19 2006 Ivan Brunello <ibrunello at users dot sourceforge dot net> 1.2.3-2ib
- rebuild to conform the stonith subpackage to new net-snmp

* Thu Jun 30 2005 Ivan Brunello <ibrunello at users dot sourceforge dot net> 1.2.3-1ib
- new upstream
- updated to reflect new assigned uid/gid
- added improved IPsrcaddr

* Mon Mar 15 2004 Jaakko Heinonen <jheinonen@users.sourceforge.net> 1.2.0-5jh
- changed library package names
- get ha.cf, haresrouces and authkeys from doc/ directory
- updated groups to follow TSL policy

* Tue Mar 09 2004 Jaakko Heinonen <jheinonen@users.sourceforge.net> 1.2.0-4jh
- added ldirectord PreReqs
- changed groups

* Tue Mar 09 2004 Jaakko Heinonen <jheinonen@users.sourceforge.net> 1.2.0-3jh
- separated libraries to their own packages (large change)
- fixed ldirectord service installation

* Mon Mar 03 2004 Jaakko Heinonen <jheinonen@users.sourceforge.net> 1.2.0-2jh
- new patch for initialization files
- added haresources, ha.cf and authkeys files 

* Mon Mar 01 2004 Jaakko Heinonen <jheinonen@users.sourceforge.net> 1.2.0-1jh
- first TSL version based on spec file by Alan Robertson <alanr@unix.sh>
